Package org.eclipse.rdf4j.sail.shacl.ast.constraintcomponents

## Class OrConstraintComponent

- java.lang.Object
- - org.eclipse.rdf4j.sail.shacl.ast.constraintcomponents.AbstractConstraintComponent
  - - org.eclipse.rdf4j.sail.shacl.ast.constraintcomponents.LogicalOperatorConstraintComponent
    - - org.eclipse.rdf4j.sail.shacl.ast.constraintcomponents.OrConstraintComponent

- All Implemented Interfaces:
    `ConstraintComponent`, `org.eclipse.rdf4j.sail.shacl.ast.Exportable`, `org.eclipse.rdf4j.sail.shacl.ast.TargetChainInterface`

      public class OrConstraintComponent
      extends LogicalOperatorConstraintComponent

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.eclipse.rdf4j.sail.shacl.ast.constraintcomponents.ConstraintComponent

      `ConstraintComponent.Scope`

  - ### Field Summary

    - ### Fields inherited from class org.eclipse.rdf4j.sail.shacl.ast.constraintcomponents.AbstractConstraintComponent

      `VALUES_INJECTION_POINT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `OrConstraintComponent​(Resource id, ShapeSource shapeSource, org.eclipse.rdf4j.sail.shacl.ast.Cache cache, ShaclSail shaclSail)` |
    `OrConstraintComponent​(OrConstraintComponent orConstraintComponent)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `org.eclipse.rdf4j.sail.shacl.ast.SparqlFragment` | `buildSparqlValidNodes_rsx_targetShape​(org.eclipse.rdf4j.sail.shacl.ast.StatementMatcher.Variable subject, org.eclipse.rdf4j.sail.shacl.ast.StatementMatcher.Variable object, RdfsSubClassOfReasoner rdfsSubClassOfReasoner, ConstraintComponent.Scope scope, org.eclipse.rdf4j.sail.shacl.ast.StatementMatcher.StableRandomVariableProvider stableRandomVariableProvider)` |
    `ConstraintComponent` | `deepClone()` |
    `org.eclipse.rdf4j.sail.shacl.ast.ValidationQuery` | `generateSparqlValidationQuery​(ConnectionsGroup connectionsGroup, ValidationSettings validationSettings, boolean negatePlan, boolean negateChildren, ConstraintComponent.Scope scope)` |
    `PlanNode` | `generateTransactionalValidationPlan​(ConnectionsGroup connectionsGroup, ValidationSettings validationSettings, PlanNodeProvider overrideTargetNode, ConstraintComponent.Scope scope)` |
    `PlanNode` | `getAllTargetsPlan​(ConnectionsGroup connectionsGroup, Resource[] dataGraph, ConstraintComponent.Scope scope)` |
    `SourceConstraintComponent` | `getConstraintComponent()` |
    `List<org.eclipse.rdf4j.sail.shacl.ast.Shape>` | `getOr()` |
    `boolean` | `requiresEvaluation​(ConnectionsGroup connectionsGroup, ConstraintComponent.Scope scope, Resource[] dataGraph)` |
    `void` | `setTargetChain​(TargetChain targetChain)` |
    `void` | `toModel​(Resource subject, IRI predicate, Model model, Set<Resource> cycleDetection)` |

    - ### Methods inherited from class org.eclipse.rdf4j.sail.shacl.ast.constraintcomponents.AbstractConstraintComponent

      `getId, getOptimalBulkValidationApproach, getPreferredValidationApproach, getTargetChain`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### OrConstraintComponent

          public OrConstraintComponent​(Resource id,
                                       ShapeSource shapeSource,
                                       org.eclipse.rdf4j.sail.shacl.ast.Cache cache,
                                       ShaclSail shaclSail)

    - #### OrConstraintComponent

          public OrConstraintComponent​(OrConstraintComponent orConstraintComponent)

  - ### Method Detail

    - #### toModel

          public void toModel​(Resource subject,
                              IRI predicate,
                              Model model,
                              Set<Resource> cycleDetection)

    - #### setTargetChain

          public void setTargetChain​(TargetChain targetChain)

      Specified by:
        `setTargetChain` in interface `org.eclipse.rdf4j.sail.shacl.ast.TargetChainInterface`
      Overrides:
        `setTargetChain` in class `AbstractConstraintComponent`

    - #### getOr

          public List<org.eclipse.rdf4j.sail.shacl.ast.Shape> getOr()

    - #### getConstraintComponent

          public SourceConstraintComponent getConstraintComponent()

    - #### generateSparqlValidationQuery

          public org.eclipse.rdf4j.sail.shacl.ast.ValidationQuery generateSparqlValidationQuery​(ConnectionsGroup connectionsGroup,
                                                                                                ValidationSettings validationSettings,
                                                                                                boolean negatePlan,
                                                                                                boolean negateChildren,
                                                                                                ConstraintComponent.Scope scope)

      Specified by:
        `generateSparqlValidationQuery` in interface `ConstraintComponent`
      Overrides:
        `generateSparqlValidationQuery` in class `AbstractConstraintComponent`

    - #### generateTransactionalValidationPlan

          public PlanNode generateTransactionalValidationPlan​(ConnectionsGroup connectionsGroup,
                                                              ValidationSettings validationSettings,
                                                              PlanNodeProvider overrideTargetNode,
                                                              ConstraintComponent.Scope scope)

      Specified by:
        `generateTransactionalValidationPlan` in interface `ConstraintComponent`
      Overrides:
        `generateTransactionalValidationPlan` in class `AbstractConstraintComponent`

    - #### getAllTargetsPlan

          public PlanNode getAllTargetsPlan​(ConnectionsGroup connectionsGroup,
                                            Resource[] dataGraph,
                                            ConstraintComponent.Scope scope)

      Specified by:
        `getAllTargetsPlan` in interface `ConstraintComponent`
      Overrides:
        `getAllTargetsPlan` in class `AbstractConstraintComponent`

    - #### deepClone

          public ConstraintComponent deepClone()

    - #### requiresEvaluation

          public boolean requiresEvaluation​(ConnectionsGroup connectionsGroup,
                                            ConstraintComponent.Scope scope,
                                            Resource[] dataGraph)

      Specified by:
        `requiresEvaluation` in interface `ConstraintComponent`
      Overrides:
        `requiresEvaluation` in class `AbstractConstraintComponent`
      Returns:
        true if the constraint component should be evaluated, eg. if validation is needed.

    - #### buildSparqlValidNodes_rsx_targetShape

          public org.eclipse.rdf4j.sail.shacl.ast.SparqlFragment buildSparqlValidNodes_rsx_targetShape​(org.eclipse.rdf4j.sail.shacl.ast.StatementMatcher.Variable subject,
                                                                                                       org.eclipse.rdf4j.sail.shacl.ast.StatementMatcher.Variable object,
                                                                                                       RdfsSubClassOfReasoner rdfsSubClassOfReasoner,
                                                                                                       ConstraintComponent.Scope scope,
                                                                                                       org.eclipse.rdf4j.sail.shacl.ast.StatementMatcher.StableRandomVariableProvider stableRandomVariableProvider)

      Specified by:
        `buildSparqlValidNodes_rsx_targetShape` in interface `ConstraintComponent`
      Overrides:
        `buildSparqlValidNodes_rsx_targetShape` in class `AbstractConstraintComponent`